#---------------------------------------------------------------------------------------------------
# %L                                                                                               -
# chvote-fx-common                                                                                      -
# %%                                                                                               -
# Copyright (C) 2016 - 2018 République et Canton de Genève                                         -
# %%                                                                                               -
# This program is free software: you can redistribute it and/or modify                             -
# it under the terms of the GNU Affero General Public License as published by                      -
# the Free Software Foundation, either version 3 of the License, or                                -
# (at your option) any later version.                                                              -
#                                                                                                  -
# This program is distributed in the hope that it will be useful,                                  -
# but WITHOUT ANY WARRANTY; without even the implied warranty of                                   -
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                     -
# GNU General Public License for more details.                                                     -
#                                                                                                  -
# You should have received a copy of the GNU Affero General Public License                         -
# along with this program. If not, see <http://www.gnu.org/licenses/>.                             -
# L%                                                                                               -
#---------------------------------------------------------------------------------------------------

image: $IMAGE_MVN_JDK11

variables:
  DOCKER_DRIVER: overlay
  MAVEN_REPO_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository"
  MAVEN_CLI_OPTS: "--settings=$CI_PROJECT_DIR/settings.xml --batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

# Cache downloaded dependencies and plugins between builds.
# Enable per-branch caching with key "$CI_COMMIT_REF_SLUG"
cache:
  key: "$CI_COMMIT_REF_SLUG"
  paths:
    - .m2/repository

stages:
  - build

build:javadoc:
  image: $IMAGE_MVN_JDK11
  stage: build
  script:
    - mvn -B $MAVEN_REPO_OPTS $MAVEN_CLI_OPTS -DskipTests javadoc:javadoc

build:artifact:
  stage: build
  script:
    - mvn -B $MAVEN_REPO_OPTS $MAVEN_CLI_OPTS clean $SONAR_PRE_BUILD_CMD verify $SONAR_POST_BUILD_CMD
  except:
    - tags

build:deploy:
  stage: build
  script:
    - mvn -B $MAVEN_REPO_OPTS $MAVEN_CLI_OPTS clean $SONAR_PRE_BUILD_CMD deploy $SONAR_POST_BUILD_CMD
  only:
    - tags
